/*******************************************************************************
 * Copyright (c) 2009 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package org.eclipse.debug.examples.ping;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.model.ILaunchConfigurationDelegate;
import org.eclipse.debug.core.model.LaunchConfigurationDelegate;

/**
 * Example launch delegate that executes the 'ping' command.
 */
public class PingLaunchDelegate extends LaunchConfigurationDelegate implements ILaunchConfigurationDelegate {

	/**
	 * Launch configuration attribute key. The address to ping - can be an IP address or domain name.
	 */
	public static final String PING_ADDRESS = "PING_ADDRESS";
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ILaunchConfigurationDelegate#launch(org.eclipse.debug.core.ILaunchConfiguration, java.lang.String, org.eclipse.debug.core.ILaunch, org.eclipse.core.runtime.IProgressMonitor)
	 */
	public void launch(ILaunchConfiguration configuration, String mode, ILaunch launch, IProgressMonitor monitor) throws CoreException {
		// TODO: --- Exercise 1 ---
		//
		// The launch delegate generates a command line to execute the standard ping
		// command - for example, "ping www.eclipse.org". The launch configuration
		// provides the domain name or IP address to ping. If no address is specified
		// a default can be used (such as localhost).
		//
		// The command line should be "exec'd" to create a system process, which can then
		// be wrapped in an IProcess and added to the provided launch object. The DebugPlugin
		// provides convenience methods for this.
	}

}
